﻿using UnityEngine;
using HarmonyLib;

public class LongerSigns : Mod
{
    Harmony harmony;

    public void Start()
    {
        harmony = new Harmony("com.jsmith.longersigns");
        harmony.PatchAll();
        Debug.Log("Mod LongerSigns has been loaded!");
    }

    public void OnModUnload()
    {
        harmony.UnpatchAll("com.jsmith.longersigns");
        UnpatchExistingSigns();
        Debug.Log("Mod LongerSigns has been unloaded!");
    }

    private static void UnpatchExistingSigns()
    {
        // Create a dummy sign to get the default max character count
        var normalSign = new TextWriterObject();

        // Find all existing signs in the world and change their max character count to the default.
        // Note: this doesn't trim any existing text in the signs until the user edits the sign.
        var signs = FindObjectsOfType<TextWriterObject>();
        foreach(var sign in signs)
        {
            sign.maxLineCharacterCount = normalSign.maxLineCharacterCount;
        }

    }

}


[HarmonyPatch(typeof(TextWriterObject))]
public class Patch_TextWriterObject
{

    [HarmonyPatch("SetIsBeingEdited")]
    [HarmonyPostfix]
    static void SetIsBeingEdited(TextWriterObject __instance)
    {
        __instance.maxLineCharacterCount = int.MaxValue;
    }

}